"""DO NOT EDIT THIS FILE!

This file is automatically @generated by afdiankit using the follow command:

    python -m codegen && isort . && black .
"""


from typing import TYPE_CHECKING, Dict, Literal, Optional

from pydantic import BaseModel, TypeAdapter
from afdiankit.utils import UNSET, exclude_unset

from .types import (
    PostAccountBindRequestBody,
    PostAccountChangePasswordRequestBody,
    PostAccountSendVerifyCodeRequestBody,
    PostAccountSubmitCancellationRequestBody,
)

if TYPE_CHECKING:
    from afdiankit import AfdianCore


class AccountClient:
    def __init__(self, afdian: "AfdianCore"):
        self._afdian = afdian

    def post_account_send_verify_code(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/send-verify-code"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountSendVerifyCodeRequestBody).validate_python(json)
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return self._afdian.request(
            "POST",
            url,
            json=exclude_unset(json),
        )

    async def async_post_account_send_verify_code(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/send-verify-code"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountSendVerifyCodeRequestBody).validate_python(json)
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return await self._afdian.arequest(
            "POST",
            url,
            json=exclude_unset(json),
        )

    def post_account_change_password(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/change-password"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountChangePasswordRequestBody).validate_python(json)
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return self._afdian.request(
            "POST",
            url,
            json=exclude_unset(json),
        )

    async def async_post_account_change_password(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/change-password"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountChangePasswordRequestBody).validate_python(json)
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return await self._afdian.arequest(
            "POST",
            url,
            json=exclude_unset(json),
        )

    def post_account_bind(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/bind"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountBindRequestBody).validate_python(json)
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return self._afdian.request(
            "POST",
            url,
            json=exclude_unset(json),
        )

    async def async_post_account_bind(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/bind"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountBindRequestBody).validate_python(json)
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return await self._afdian.arequest(
            "POST",
            url,
            json=exclude_unset(json),
        )

    def get_account_unbind_wechat(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
    ):
        url = "/api/account/unbind-wechat"

        return self._afdian.request(
            "GET",
            url,
        )

    async def async_get_account_unbind_wechat(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
    ):
        url = "/api/account/unbind-wechat"

        return await self._afdian.arequest(
            "GET",
            url,
        )

    def post_account_submit_cancellation(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/submit-cancellation"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountSubmitCancellationRequestBody).validate_python(
            json
        )
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return self._afdian.request(
            "POST",
            url,
            json=exclude_unset(json),
        )

    async def async_post_account_submit_cancellation(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
        data: Literal[UNSET] = UNSET,
        **kwargs,
    ):
        url = "/api/account/submit-cancellation"

        if not kwargs:
            kwargs = UNSET

        json = kwargs if data is UNSET else data
        json = TypeAdapter(PostAccountSubmitCancellationRequestBody).validate_python(
            json
        )
        json = json.model_dump(by_alias=True) if isinstance(json, BaseModel) else json

        return await self._afdian.arequest(
            "POST",
            url,
            json=exclude_unset(json),
        )

    def get_account_check_cancellation(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
    ):
        url = "/api/account/check-cancellation"

        return self._afdian.request(
            "GET",
            url,
        )

    async def async_get_account_check_cancellation(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
    ):
        url = "/api/account/check-cancellation"

        return await self._afdian.arequest(
            "GET",
            url,
        )

    def post_account_cancel_cancellation(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
    ):
        url = "/api/account/cancel-cancellation"

        return self._afdian.request(
            "POST",
            url,
        )

    async def async_post_account_cancel_cancellation(
        self,
        *,
        headers: Optional[Dict[str, str]] = None,
    ):
        url = "/api/account/cancel-cancellation"

        return await self._afdian.arequest(
            "POST",
            url,
        )
